#include <stdio.h>
#include <stdlib.h>
#include "q.h"

int myenter(char *objname, int priority){
	int len, s_qid;
	struct q_entry s_entry;

	if ( (len=strlen(objname)) > MAXOBN){
		printf("name too long\n"); exit(1);
		}
	if ( priority > MAXPRIOR || priority < 0 ){
		printf("invalid priority level"); return(-1);
		}
	if ( (s_qid = init_queue()) == -1 ) 
		return(-1);
	else    printf("Entering Queue with ID: %d \n",s_qid);
	
	s_entry.mtype= (long)priority;
	strncpy(s_entry.mtext, objname, MAXOBN);

	if (msgsnd(s_qid, &s_entry, len, 0) == -1 ){
		perror("msgsnd failed"); return(-1);}
	else	{
		printf("Object %s With Priority %ld has been Enqueued Successfully \n",\
			s_entry.mtext, s_entry.mtype);	
		return(0);
		}
}

main(int argc, char *argv[]){
	int priority;
	
	if ( argc!= 3){
		fprintf(stderr,"usage: %s objname priority\n",argv[0]);
		}
	if ((priority = atoi(argv[2])) <=0 || priority > MAXPRIOR){	
		printf("invalid priority"); 
		exit(2);
		}

	if ( myenter(argv[1], priority) < 0 ){
		printf("enter failure"); 
		exit(3);
		}
	exit(0);
}
